<template>
    <div class="select-part">

        <div v-click-outside="hide" @click="toggle" class="choosen-item"> {{variable}}</div>
        <div v-show="opened" class="drop-down">
            <div class="item-category" v-if="routeType === 'ChannelsList' || routeType === 'CamsList'" @click="choose({id:'All', title: 'Все'})"> Все </div>
            <div class="item-category" v-if="routeType === 'ChannelsList' || routeType === 'CamsList'" @click="choose({id:'favorite', title: 'Избранные'})"> Избранные </div>
            <div class="item-category" v-if="routeType === 'ChannelsList'" @click="choose({id:'top', title: 'TOП каналы'})"> TOП каналы </div>
            <div class="item-category" v-if="routeType === 'FilmsList'" @click="choose({id:'top', title: 'TOП фильмы'})"> TOП фильмы </div>
            <div class="item-category" v-if="routeType === 'FilmsList'" @click="choose({id:'topMonth', title: 'TOП за месяц'})"> TOП за месяц </div>
            <div class="item-category" v-if="routeType === 'FilmsList'" @click="choose({id:'topToday', title: 'Смотрели сегодня'})"> Смотрели сегодня </div>
            <div class="item-category" v-for="genre in list" :data-id="genre.id" @click="choose({id: genre.id, title: genre.title})"> {{genre.title }} </div>
        </div>
    </div>
</template>

<script>
    import ClickOutside from 'vue-click-outside'

    export default {
        props: ['list','choosen', 'routeType'],
        name: "select",
        data () {
            return {
                opened: false,
            }
        },
        computed: {
            variable() {
                return this.choosen ? this.choosen : 'Все'
            }
        },
        methods: {
            toggle() {
                this.opened = true
            },
            hide() {
                this.opened = false
            },
            updatePage(genre) {
                this.$router.push({ path: '#', params: { genreFilter: genre }});
            },
            choose(type) {
                this.$emit('choose', type);
                this.opened = false;
                this.$store.state.paginationPage = 0;
            }
        },
        mounted () {
            this.popupItem = this.$el
        },
        directives: {
            ClickOutside
        }
    }
</script>

<style scoped>
    .select-part {
        min-width: 210px;
        max-width: 210px;
        margin: 0 10px;
        position: relative;
        height: 40px;
        z-index: 9999;
    }
    .choosen-item {
        background: #fff;
        padding: 5px 10px;
        height: 40px;
        line-height: 30px;
        border-radius: 5px;
        cursor: pointer;
    }
    .choosen-item span {
        color: #757575;
    }

    .drop-down {
        max-height: 70vh;
        overflow-x: hidden;
        overflow-y: auto;
        width: 100%;
        background: #fff;
        margin-top: -5px;
        padding: 15px 10px;
        box-shadow: 0 3px 3px rgba(0,0,0,0.15);
        border-radius: 0 0 5px 5px;
        display: flex;
        flex-wrap: wrap;
    }
    .drop-down .item-category {
        display: block;
        padding: 2px 0;
        cursor: pointer;
        color: #478dcd;
        min-width: 100%;
        max-width: 100%;
        order: 2;
    }
    .drop-down .item-category[data-id="All"] {
        order: 1;
    }
    .drop-down .item-category:hover {
        color: #4779b9;
    }
</style>
